Index: src/checks.py
===================================================================
--- src/checks.py	(revision 11)
+++ src/checks.py	(revision 13)
@@ -122,5 +122,5 @@
         """Construct the logger."""
         self._logged = False
-        self._spoilerExtension = None
+        self._spoilersExtension = None
     
     def check(self, flight, aircraft, logger, oldState, state):
@@ -128,9 +128,9 @@
         if flight.stage==const.STAGE_LANDING and not self._logged:
             if state.onTheGround:
-                if state.spoilerExtension!=self._spoilerExtension:
+                if state.spoilersExtension!=self._spoilersExtension:
                     logger.message(state.timestamp, "Spoilers deployed")
                     self._logged = True
             else:
-                self._spoilerExtension = state.spoilerExtension
+                self._spoilersExtension = state.spoilersExtension
 
 #---------------------------------------------------------------------------------------
@@ -456,5 +456,5 @@
     def logFault(self, flight, aircraft, logger, oldState, state):
         """Log the fault."""
-        logger.fault(AntiCollisionLightChecker, state.timestamp,
+        logger.fault(AntiCollisionLightsChecker, state.timestamp,
                      FaultChecker._appendDuring(flight, "Anti-collision lights were off"),
                      1)
@@ -486,4 +486,8 @@
 class FlapsRetractChecker(SimpleFaultChecker):
     """Check if the flaps are not retracted too early."""
+    def __init__(self):
+        """Construct the flaps checker."""
+        self._timeStart = None
+    
     def isCondition(self, flight, aircraft, oldState, state):
         """Check if the fault condition holds.
@@ -497,4 +501,6 @@
             if state.flapsSet==0 and state.timestamp<=(self._timeStart+2.0):
                 return True
+        else:
+            self._timeStart = None
         return False
 
@@ -542,5 +548,5 @@
     def isCondition(self, flight, aircraft, oldState, state):
         """Check if the fault condition holds."""
-        return state.gearsDown and state.ias>gearSpeedLimit
+        return state.gearsDown and state.ias>aircraft.gearSpeedLimit
 
     def logFault(self, flight, aircraft, logger, oldState, state):
@@ -616,5 +622,5 @@
             if flight.options.compensation is not None:
                 limit += flight.options.compensation
-            return state.grossWeight>mlw
+            return self.getWeight(state)>limit
 
         return False
@@ -622,7 +628,13 @@
     def logFault(self, flight, aircraft, logger, oldState, state):
         """Log the fault."""
+        mname = "M" + self._name
         logger.noGo(self.__class__, state.timestamp,
-                    "%s exceeded: %.0f kg" % (self._name, state.grossWeight),
-                    "%s NO GO" % (self._name,))
+                    "%s exceeded: %s is %.0f kg" % \
+                    (mname, self._name, self.getWeight(state)),
+                    "%s NO GO" % (mname,))
+
+    def getWeight(self, state):
+        """Get the weight that is interesting for us."""
+        return state.grossWeight
 
 #---------------------------------------------------------------------------------------
@@ -632,7 +644,7 @@
     def __init__(self):
         """Construct the checker."""
-        super(MLWChecker, self).__init__("MLW")
-
-    def getLimit(flight, aircraft, state):
+        super(MLWChecker, self).__init__("LW")
+
+    def getLimit(self, flight, aircraft, state):
         """Get the limit if we are in the right state."""
         return aircraft.mlw if flight.stage==const.STAGE_LANDING and \
@@ -645,7 +657,7 @@
     def __init__(self):
         """Construct the checker."""
-        super(MTOWChecker, self).__init__("MTOW")
-
-    def getLimit(flight, aircraft, state):
+        super(MTOWChecker, self).__init__("TOW")
+
+    def getLimit(self, flight, aircraft, state):
         """Get the limit if we are in the right state."""
         return aircraft.mtow if flight.stage==const.STAGE_TAKEOFF else None
@@ -657,9 +669,13 @@
     def __init__(self):
         """Construct the checker."""
-        super(MZFWChecker, self).__init__("MZFW")
-
-    def getLimit(flight, aircraft, state):
+        super(MZFWChecker, self).__init__("ZFW")
+
+    def getLimit(self, flight, aircraft, state):
         """Get the limit if we are in the right state."""
         return aircraft.mzfw
+
+    def getWeight(self, state):
+        """Get the weight that is interesting for us."""
+        return state.zfw
 
 #---------------------------------------------------------------------------------------
@@ -725,5 +741,5 @@
     def isCondition(self, flight, aircraft, oldState, state):
         """Check if the fault condition holds."""
-        return state.groundSpeed>80 and not current.pitotHeatOn
+        return state.groundSpeed>80 and not state.pitotHeatOn
                
     def logFault(self, flight, aircraft, logger, oldState, state):
@@ -765,5 +781,5 @@
         """Log the fault."""
         logger.fault(SpeedChecker, state.timestamp,
-                     FaultChecker._appendDuring(flight, "Reverser used below 60 knots"),
+                     FaultChecker._appendDuring(flight, "Taxi speed over 50 knots"),
                      FaultChecker._getLinearScore(50, 80, 10, 15, state.groundSpeed))
 
@@ -821,4 +837,5 @@
     def logFault(self, flight, aircraft, logger, oldState, state):
         """Log the fault."""
+        print state.n1
         logger.fault(LandingLightsChecker, state.timestamp,
                      FaultChecker._appendDuring(flight, "Thrust setting was too high (>97%)"),
@@ -841,11 +858,11 @@
         return vs < -8000 or vs > 8000 or \
                (altitude<500 and vs < (VSChecker.BELOW500 *
-                                       VSCHECKER.TOLERANCE)) or \
+                                       VSChecker.TOLERANCE)) or \
                (altitude<2500 and vs < (VSChecker.BELOW2500 *
-                                        VSCHECKER.TOLERANCE)) or \
+                                        VSChecker.TOLERANCE)) or \
                (altitude<5000 and vs < (VSChecker.BELOW5000 *
-                                        VSCHECKER.TOLERANCE)) or \
+                                        VSChecker.TOLERANCE)) or \
                (altitude<10000 and vs < (VSChecker.BELOW10000 *
-                                         VSCHECKER.TOLERANCE))
+                                         VSChecker.TOLERANCE))
                
     def logFault(self, flight, aircraft, logger, oldState, state):