Index: .hgignore
===================================================================
--- .hgignore	(revision 20)
+++ .hgignore	(revision 26)
@@ -4,2 +4,3 @@
 dist/.+
 build/.+
+mlx-common.nsh
Index: src/checks.py
===================================================================
--- src/checks.py	(revision 25)
+++ src/checks.py	(revision 26)
@@ -476,8 +476,11 @@
     def isCondition(self, flight, aircraft, oldState, state):
         """Check if the fault condition holds."""
+        isTupolev = aircraft.type in [const.AIRCRAFT_T134, 
+                                      const.AIRCRAFT_T154]
         return (flight.stage!=const.STAGE_PARKING or \
                 not flight.options.fs2Crew) and \
                 not state.antiCollisionLightsOn and \
-                max(state.n1)>5
+                ((isTupolev and max(state.n1[1:])>5) or \
+                 (not isTupolev and max(state.n1)>5))
 
     def logFault(self, flight, aircraft, logger, oldState, state):
@@ -835,13 +838,18 @@
     def isCondition(self, flight, aircraft, oldState, state):
         """Check if the fault condition holds."""
-        return (flight.stage==const.STAGE_BOARDING and \
-                state.strobeLightsOn and state.onTheGround) or \
-               (flight.stage==const.STAGE_TAKEOFF and \
-                not state.strobeLightsOn and not state.gearsDown) or \
-               (flight.stage in [const.STAGE_CLIMB, const.STAGE_CRUISE,
-                                 const.STAGE_DESCENT] and \
-                not state.strobeLightsOn and not state.onTheGround) or \
-               (flight.stage==const.STAGE_PARKING and \
-                state.strobeLightsOn and state.onTheGround)
+        if aircraft.type in [const.AIRCRAFT_T134,
+                             const.AIRCRAFT_T154,
+                             const.AIRCRAFT_YK40]:
+            return False
+        else:
+            return (flight.stage==const.STAGE_BOARDING and \
+                    state.strobeLightsOn and state.onTheGround) or \
+                   (flight.stage==const.STAGE_TAKEOFF and \
+                    not state.strobeLightsOn and not state.gearsDown) or \
+                   (flight.stage in [const.STAGE_CLIMB, const.STAGE_CRUISE,
+                                     const.STAGE_DESCENT] and \
+                   not state.strobeLightsOn and not state.onTheGround) or \
+                   (flight.stage==const.STAGE_PARKING and \
+                    state.strobeLightsOn and state.onTheGround)
                
     def logFault(self, flight, aircraft, logger, oldState, state):
Index: src/fsuipc.py
===================================================================
--- src/fsuipc.py	(revision 23)
+++ src/fsuipc.py	(revision 26)
@@ -12,4 +12,5 @@
 import calendar
 import sys
+import codecs
 
 if os.name == "nt":
@@ -474,5 +475,7 @@
         self._flareStart = None
         self._flareStartFS = None
-        
+    
+        self._latin1decoder = codecs.getdecoder("iso-8859-1")
+    
     def connect(self, aircraft):
         """Initiate a connection to the simulator."""
@@ -592,6 +595,8 @@
         if needNew:
             self._setAircraftModel(AircraftModel.create(self._aircraft, aircraftName))
-        
-        self._aircraft.modelChanged(timestamp, name, self._aircraftModel.name)        
+ 
+        
+        self._aircraft.modelChanged(timestamp, self._latin1decoder(name), 
+                                    self._aircraftModel.name)        
 
         return needNew
Index: src/mlx.py
===================================================================
--- src/mlx.py	(revision 24)
+++ src/mlx.py	(revision 26)
@@ -392,5 +392,5 @@
         table.attach(self._nav2, 11, 12, 3, 4)
 
-        (label, self._fuel) = self._createLabeledEntry("Fuel:", 20, xalign = 0.0)
+        (label, self._fuel) = self._createLabeledEntry("Fuel:", 40, xalign = 0.0)
         table.attach(label, 0, 1, 4, 5)
         table.attach(self._fuel, 1, 4, 4, 5)
@@ -521,5 +521,5 @@
             for fuel in aircraftState.fuel:
                 if fuelStr: fuelStr += ", "
-                fuelStr += "%.0f" % (fuel,)
+                fuelStr += "%.0f" % (fuel,)                
             self._fuel.set_text(fuelStr)
 