Index: MLXMANIFEST
===================================================================
--- MLXMANIFEST	(revision 639)
+++ MLXMANIFEST	(revision 646)
@@ -7,5 +7,5 @@
 library/fnmatch.pyc	3414	4d50000f78e903598af06ef1c5cfb3ef
 library/libexpat-1.dll	143096	701659d3689bf4a8265b669b7d774255
-library/gtk/_gtk.pyc	549	90c4cc7c877e95ae51470c4d6a89a98c
+library/gtk/_gtk.pyc	549	912fc62c643ffabf11f8aeee5357248a
 library/encodings/cp858.pyc	7591	02054a0b8e91b9758826eb70cddf096f
 library/mlx/pirep.pyc	4623	2a008f269c900fb604b94b4e427f61b5
@@ -22,5 +22,5 @@
 doc/manual/hu/bugreport.png	12385	c71c7db56f19870ae5d6bb7f533d3679
 library/share/locale/hu/LC_MESSAGES/gtk20.mo	58794	6ee4491ae7bc9d3dfb778578eb29a0b3
-library/gobject/_gobject.pyc	573	b6488c36d066d870dd49a1f7aa9ead4d
+library/gobject/_gobject.pyc	573	b43e85aeeb90ab61e54c43192b5c26a8
 locale/en/LC_MESSAGES/mlx.mo	64494	5eb2e430656c49a02122e3ea54fe4698
 library/encodings/utf_7.pyc	1747	2beeb059236527197d6c640396476ce8
@@ -76,5 +76,5 @@
 library/_hashlib.pyd	287232	a1a18de0644f481749fcbcf26005eeaf
 doc/manual/en/monitorWindow.png	20886	42e08d10c758e21209c4c021f391dee7
-library/_hashlib.pyc	549	781e65065d48266563cc9a60faa1a86d
+library/_hashlib.pyc	549	66f9660d64bea9f69c02b2642cd94a21
 library/libpng14-14.dll	230529	f3a15497e25baaa721f96638d7a4d2f8
 library/copy.pyc	11674	30d1745c5e38ab170f8a0486fbebf305
@@ -137,6 +137,6 @@
 doc/manual/en/prefsAdvanced.png	16169	64c14e0842c413cac98b92926279f3e0
 library/mlx/pyuipc_sim.pyc	57183	11246ecca37406ce4b90df909f752189
-library/cairo/_cairo.pyc	561	0b00a99621ea708969698783f95364a0
-library/win32file.pyc	552	e73b04f27b6c933e343df14e93a2da8d
+library/cairo/_cairo.pyc	561	466b13dfc423420ebeaad4ebcf0c421c
+library/win32file.pyc	552	27f9806248238d8076b22916d00ea4d7
 library/encodings/cp865.pyc	7868	7d40a7ba053ac23339218be8799e5397
 library/lib/gtk-2.0/2.10.0/engines/libwimp.dll	97984	a5bbbe46e1363aba9020a76f2d58e9d6
@@ -148,5 +148,5 @@
 library/share/locale/hu/LC_MESSAGES/gtk20-properties.mo	167125	cd1b1b3693c1e3c74bfcea20be640cc6
 conn_red.png	914	860388cb7c3b26b2f348fdbee40780ce
-library/bz2.pyc	534	59c15ab8307bbf65d2100a014f92d1b3
+library/bz2.pyc	534	9d4100e3ccbf722cb2a70239f1074a53
 library/xml/sax/expatreader.pyc	13563	4f64c0efb2f1f8dbba84cdb5c6036f2d
 library/email/utils.pyc	8840	a7be428df6fddee6121cfce55382d1f8
@@ -164,6 +164,6 @@
 library/mlx/gui/statusbar.pyc	4812	87773f7d0bd28ed6250acf1972110ca8
 library/warnings.pyc	12666	9788b5f45765e8204e04c820f2711094
-mlxupdate.exe	19456	80a750f0dba08e4c2340e5b510e20c7f
-library/mlx/const.pyc	6269	a809f24959733c60e9cb2c24dc329223
+mlxupdate.exe	19456	6c1ca467b300cb19cda15d8f28bf989d
+library/mlx/const.pyc	6269	1029d0e2b4d51d6428dddcfbf2c9c0e5
 library/email/errors.pyc	3229	cdb78ab237e195ad69f059128bc03b1d
 library/linecache.pyc	3091	666e6f81b0ea9a7637f8068493f738d5
@@ -178,5 +178,5 @@
 library/shlex.pyc	7282	cbe1a4823894c97c87d01f9d9faf5b8f
 library/cairo/__init__.pyc	142	010dd7cc8485565d5782d60e92e4ba34
-library/_ssl.pyc	537	a4c1a2ef6477b59abb2bb620586f54a2
+library/_ssl.pyc	537	b2b4bf830369edf6eb9fecf4c1908dd0
 library/encodings/iso8859_8.pyc	2717	f3ad6ce58cfac9e3ca86cf5c2fef092b
 library/encodings/iso2022_jp_1.pyc	1699	faed9d5747e982cec9fa8b3ad8e1de26
@@ -198,6 +198,6 @@
 library/encodings/cp1252.pyc	2676	b4c43cc72650c911cf3654dbaf565df9
 library/share/locale/hu/LC_MESSAGES/atk10.mo	8465	e3f3466da367215aad971d7b0394229d
-library/unicodedata.pyc	558	a8bace28fe6caffe3ec683bbfc1ccaa1
-library/select.pyc	543	da46d9367553949200a8df2f681b3775
+library/unicodedata.pyc	558	e73ef452b90e2d20e58da4b102ce1624
+library/select.pyc	543	41e96f37dd79e688b6aa9568fc0223cc
 library/encodings/uu_codec.pyc	4646	5282a5fcb676851224d2924aa3e48a9e
 library/ConfigParser.pyc	23857	1d17020dd0000ce0f73de812effa152f
@@ -231,5 +231,5 @@
 doc/manual/hu/flightInfoTab.png	28786	3e8af27775131f02696b0912ca441f36
 library/encodings/utf_8_sig.pyc	4625	1b1405db186e5819fa271ff96c1ca2c5
-library/pangocairo.pyc	555	6bdcc4eded419f58d1624da960f7ad6c
+library/pangocairo.pyc	555	2950ca1cee4b2b2fc820f8ca41f42c30
 library/encodings/cp1255.pyc	2697	b265913c887f2e1c8736632b652c0093
 library/encodings/zlib_codec.pyc	4308	319c9073aff840436a03cc1fa0b08fb5
@@ -244,5 +244,5 @@
 library/intl.dll	152489	eb2d4c4d4a527bc88a69a16cc99afcf5
 library/encodings/mbcs.pyc	1883	2213911a7dd0deada6799b63e18b695b
-library/pyuipc.pyc	543	9e541a1b922752cc84fb15d7eaa2457c
+library/pyuipc.pyc	543	48c09a7958b660571f78b861c7e83915
 sounds/TOC.mp3	273032	fae1be2ad25c8b54806bd1d759919705
 library/encodings/iso8859_4.pyc	2678	16f2fe7994051752360c533c052b892b
@@ -268,11 +268,11 @@
 doc/manual/hu/flightSelection.png	30815	e8bcdda6079c6b16ffa72ca62c21ca85
 library/win32pipe.pyd	24064	de374eded459293b2a7eb8ed8fb38eaa
-library/win32pipe.pyc	552	99686fbb16572d83832608fc46ac2a26
+library/win32pipe.pyc	552	19b38550113abf2ade8c92acbde0683e
 doc/manual/hu/cruise.png	27460	a2610173563e45baae1b0f9e63007ebd
 doc/manual/hu/logTab.png	28706	f48004202310bd2a1cb2f873d8064e93
 library/encodings/iso2022_jp_2004.pyc	1723	66376e788f3819e781897268c1100986
-library/win32event.pyc	555	8720bc85b5fbc21f64bd94faee0f553c
+library/win32event.pyc	555	bd38c26420508b66ecbefd6d77f33ed5
 library/encodings/cp866.pyc	8103	f36418dcf93b17b3ced63bd544f44159
-library/gio/_gio.pyc	549	d0dfd8bcba59352dc5f674cc0824b6dc
+library/gio/_gio.pyc	549	cfbd49beee4edf38f0b4beaf063ca7e6
 library/encodings/cp437.pyc	7874	63f1278c0a66129c6fb4f504d6b61b66
 doc/manual/hu/helpTab.png	27961	8e7cc4aeb8d7f40fcf186c7caf53583b
@@ -298,5 +298,5 @@
 library/mlx/gui/pirep.pyc	16749	7a295b28dbdad43b33c52d814be60792
 library/mimetypes.pyc	17806	927ce6a7079707aaee925e855ed23454
-library/_ctypes.pyc	546	49d70aef2ba4906c1cb6617378b2792f
+library/_ctypes.pyc	546	57b7261471c2a92fbb5b72ba79f140eb
 library/mlx/gui/faultexplain.pyc	9707	3bda0c4c25476cd8c11e4d1c15c682bd
 sounds/F70taxi.mp3	154854	51332dc691d3519355f61ed06c959d8d
@@ -330,5 +330,5 @@
 library/unittest/case.pyc	37758	1d2235e74c246b562c5c00ddf73c621a
 library/subprocess.pyc	38648	c9f749db06dfc9fb32079de51d6efd01
-library/mlx/acft.pyc	39203	c69073205b0c5cfc8a11f552bd0ff4c4
+library/mlx/acft.pyc	39301	73a41faa55921dbe926e3e7d0ee0554f
 library/gobject._gobject.pyd	113152	3d05dd191361f83aa247b62c700fa04e
 doc/manual/hu/checklistEditor.png	27863	8c750892a52dc10ca654a9d0b2765358
@@ -344,5 +344,5 @@
 library/encodings/cp863.pyc	7868	fc7ff06dab536b93c68fcb8e7bac713f
 library/xml/parsers/__init__.pyc	294	83f6a77ed8cd962b3c75c4779dc557ac
-library/pyexpat.pyc	546	aff4528c1f1ebcf2763dd37a77a68eb6
+library/pyexpat.pyc	546	845299b314795369ebbbddbbd9c18856
 doc/manual/hu/gateSelection.png	29237	bac37e7001261a40a84e4202247f6052
 library/cmd.pyc	13512	808f813d5e354b7073a1356e44c7b554
@@ -370,19 +370,19 @@
 library/_socket.pyd	38400	5d273be76603399e88cf57f2605004bf
 sounds/ding.wav	80856	18e639792d3767436ac6955eb60e4f54
-library/_socket.pyc	546	1ff57dda41d4debc02f4635083dbba8f
+library/_socket.pyc	546	af7c2fad77e48b8326b4d1a255d23182
 library/encodings/hex_codec.pyc	3520	a8b8d5b7c8810379c7007bcbc253951c
-library/mlx/checks.pyc	62608	98788c08ab0308d000576390f67f62f0
+library/mlx/checks.pyc	62701	b6686225a757818b65eff015fbae59cb
 doc/manual/en/statusIcon2.png	5875	71fc121823dee0a4c00715fac1b5665c
 library/mlx/sound.pyc	8226	e8ca9ac1842f9e548b60e0d4f5648fcb
 doc/manual/en/pirepViewer.png	25098	7c545e70b995ac0f9fcae93fe5d0e899
 library/encodings/aliases.pyc	8750	75c22196420d0157fec085d285947a71
-library/glib/_glib.pyc	555	14d8fe6911caf882a40d27c9554b3883
+library/glib/_glib.pyc	555	c632852924647422037e2440bd828442
 library/libpangowin32-1.0-0.dll	108945	d07f128828225b7cc38e9e590eb3ba8a
 library/encodings/iso8859_10.pyc	2693	5e6cc8f721486ddbc1c99da285e13191
-library/win32api.pyc	549	5362e4d2603472f2c046f4fdd274a365
+library/win32api.pyc	549	cd5313d76b63216a5fc6b85eb02a0aa9
 library/gobject/constants.pyc	1957	2e9cdc605e7c449ef4fc23f56128acec
 library/libgtk-win32-2.0-0.dll	4938115	cc6dca192aca6f91bd96a5b5f86e036d
 doc/manual/hu/calloutsEditor.png	16026	fede870894a85e5d21ca16a026aa6a98
-library/mlx/xplane.pyc	66527	c3fd0bc9253950ca9da8807241867920
+library/mlx/xplane.pyc	67098	5592e5201555656aee2ce230d023251c
 library/ssl.pyc	13785	d90c880699ecbedb3182f556b9733868
 library/tempfile.pyc	18526	e2cc2d63c29e15f20ee9325e790643a3
@@ -428,5 +428,5 @@
 library/glib._glib.pyd	58368	0de636503e43c4eb00e80927bc9bda97
 library/mlx/config.pyc	30521	f56ff616c07f5620d02da08a98040f21
-library/atk.pyc	534	bde49ec6b38e9dd0cf9bd651ec00d833
+library/atk.pyc	534	7ecf77a8c1a05289435f2b40ec3ab2d6
 library/gio._gio.pyd	263168	acb8c95fdc391079bebdf7d8685b0dbc
 library/encodings/cp861.pyc	7868	c97a8970ce4d9f40cbafbea6576fbdca
@@ -438,5 +438,5 @@
 library/__future__.pyc	4177	43d264d951ac2085334c7b9dd4558595
 library/logging/__init__.pyc	54813	7bcdf2e8da474f5e94d8e499f6fc3ed4
-runmlx.exe	64000	7b33f09e92708c1e60955e4d89f48022
+runmlx.exe	64000	2ffc460fa196d67ba2c5199105b33e2f
 library/optparse.pyc	51253	39594a40bc1222173d57b7d5740e3d92
 library/mlx/fs.pyc	11803	51e819778a86c4e4e6a70ef191a9012c
@@ -451,5 +451,5 @@
 library/glib/option.pyc	11891	bd90183c75d8f473ecf653e3d63a27f9
 library/StringIO.pyc	11100	f4eb4a2bb3d6fb0af925681c5375c673
-library/pango.pyc	540	3252e647688adca7cf6c07adc13ebd32
+library/pango.pyc	540	c85d100b6f9c981e0285d126972a2681
 Microsoft.VC90.CRT/msvcp90.dll	568832	6de5c66e434a9c1729575763d891c6c2
 library/sre_parse.pyc	18380	fe2376a101668be1124f9ee316662bab